package com.madeu.service.web.webstocksumadjustment.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.madeu.constants.Constants;
import com.madeu.dao.web.webauthmenurelation.WebAuthMenuRelationSqlMapDAO;
import com.madeu.dao.web.webmember.WebMemberSqlMapDAO;
import com.madeu.dao.web.webstocksum.WebStockSumSqlMapDAO;
import com.madeu.service.web.webstocksumadjustment.WebStockSumAdjustmentService;
import com.madeu.util.ValidationCheckUtil;

import lombok.extern.slf4j.Slf4j;

@Slf4j
@Service("WebStockSumAdjustmentService")
public class WebStockSumAdjustmentServiceImpl implements WebStockSumAdjustmentService {
	
	@Autowired
	private WebStockSumSqlMapDAO webStockSumAdjustmentSqlMapDAO;
	
	@Autowired
	private WebMemberSqlMapDAO webMemberSqlMapDAO;
	
	@Autowired
	private WebAuthMenuRelationSqlMapDAO webAuthMenuRelationSqlMapDAO;
	
	/**
	 * 제품별 실시간 재고 현황 리스트 (재고조정 화면) 리스트 조회 화면으로 이동.
	 *
	 *
	 * @param paramMap
	 * @return
	 * @throws Exception
	 */
	@Override
	public HashMap<String, Object> selectListStockSumAdjustmentIntro(
			HashMap<String, Object> paramMap) throws Exception {
		log.debug("WebStockSumAdjustmentServiceImpl selectListStockSumAdjustmentIntro START");

		HashMap<String, Object> map = new HashMap<String, Object>();

		log.debug("loginMemberId       :"+paramMap.get("loginMemberId"));
		
		log.debug("menuClass           :"+paramMap.get("menuClass"));
		
		try{
			boolean check  = true;
			
			String menuClass    = String.valueOf(paramMap.get("menuClass"));
			
			// 정렬
			if(true != ValidationCheckUtil.emptyCheck(menuClass)){
				check = false;
				map.put("msgCode", Constants.FAIL);
				map.put("msgDesc","메뉴 정보가 없습니다.");
			}

			if(true == check){
				// 사용자 확인
				List<Map<String, Object>> userListMap = webMemberSqlMapDAO.checkMember(paramMap);
				int userListMapSize = userListMap.size();
				
				if(1==userListMapSize){
					paramMap.put("menuClassAuthId", userListMap.get(0).get("muAuthId"));
				}
				else {
					check = false;
					map.put("msgCode", Constants.FAIL);
					map.put("msgDesc", "사용자 정보가 올바르지 않습니다.");
				}
			}
			
			if(true == check){
				// 권한 조회
				HashMap<String, Object> authCheckParamMap = new HashMap<String, Object>();
				authCheckParamMap.put("menuClass",paramMap.get("menuClass"));
				authCheckParamMap.put("muAuthId",paramMap.get("menuClassAuthId"));
				List<Map<String, Object>> authMenuRelationlistMap = webAuthMenuRelationSqlMapDAO.selectAuthMenuRelation(authCheckParamMap);
				int authMenuRelationlistMapSize = authMenuRelationlistMap.size();
				
				if(1==authMenuRelationlistMapSize){
					map.put("msgCode", Constants.OK);
					map.put("success","true");
					
					map.put("selectUseYn", authMenuRelationlistMap.get(0).get("selectUseYn"));
					map.put("insertUseYn", authMenuRelationlistMap.get(0).get("insertUseYn"));
					map.put("updateUseYn", authMenuRelationlistMap.get(0).get("updateUseYn"));
					map.put("deleteUseYn", authMenuRelationlistMap.get(0).get("deleteUseYn"));
					map.put("downloadUseYn", authMenuRelationlistMap.get(0).get("downloadUseYn"));
				}
				else {
					map.put("msgCode", Constants.FAIL);
					map.put("msgDesc", "권한 정보가 없습니다.");
				}
			}
		}
		catch(Exception e){
			e.printStackTrace();
			throw e;
		}

		log.debug("WebStockSumAdjustmentServiceImpl selectListStockSumAdjustmentIntro END");
		return map;
	}
	
	/**
	 * 제품별 실시간 재고 현황 리스트 (재고조정 화면) 조회
	 *
	 *
	 * @param paramMap
	 * @return
	 * @throws Exception
	 */
	@Override
	public HashMap<String, Object> selectListStockSumAdjustment(
			HashMap<String, Object> paramMap) throws Exception {
		log.debug("WebStockSumAdjustmentServiceImpl selectListStockSumAdjustment START");

		HashMap<String, Object> map = new HashMap<String, Object>();

		log.debug("loginMemberId       :"+paramMap.get("loginMemberId"));
		
		log.debug("menuClass           :"+paramMap.get("menuClass"));
		
		log.debug("stockSumAdjustmentSearchKeywordParam  :"+paramMap.get("stockSumAdjustmentSearchKeywordParam"));
		log.debug("stockSumAdjustmentSort                :"+paramMap.get("stockSumAdjustmentSort"));
		log.debug("stockSumAdjustmentStart               :"+paramMap.get("stockSumAdjustmentStart"));
		log.debug("stockSumAdjustmentLimit               :"+paramMap.get("stockSumAdjustmentLimit"));
		log.debug("stockSumAdjustmentSort                :"+paramMap.get("stockSumAdjustmentSort"));
		log.debug("stockSumAdjustmentDir                 :"+paramMap.get("stockSumAdjustmentDir"));
		log.debug("stockSumAdjustmentCurrentPage         :"+paramMap.get("stockSumAdjustmentCurrentPage"));
		
		List<Map<String, Object>> listMap = new ArrayList<Map<String,Object>>();

		try{
			boolean check  = true;
			
			if(true == check){
				// 사용자 확인
				List<Map<String, Object>> userListMap = webMemberSqlMapDAO.checkMember(paramMap);
				int userListMapSize = userListMap.size();
				
				if(1==userListMapSize){
					paramMap.put("menuClassAuthId", userListMap.get(0).get("muAuthId"));
				}
				else {
					check = false;
					map.put("msgCode", Constants.FAIL);
					map.put("msgDesc", "사용자 정보가 올바르지 않습니다.");
				}
			}

			if(true == check){
				// 권한 조회
				HashMap<String, Object> authCheckParamMap = new HashMap<String, Object>();
				authCheckParamMap.put("menuClass",paramMap.get("menuClass"));
				authCheckParamMap.put("muAuthId",paramMap.get("menuClassAuthId"));
				List<Map<String, Object>> authMenuRelationlistMap = webAuthMenuRelationSqlMapDAO.selectAuthMenuRelation(authCheckParamMap);

				if(1==authMenuRelationlistMap.size()){

					if(("Y").equals(authMenuRelationlistMap.get(0).get("selectUseYn"))) {

					}
					else {
						check = false;
						map.put("msgCode", Constants.FAIL);
						map.put("msgDesc", "조회 권한 정보가 없습니다.");
					}
				}
				else {
					check = false;
					map.put("msgCode", Constants.FAIL);
					map.put("msgDesc", "권한 정보가 없습니다.");
				}
			}

			if(true == check){
				// 정렬 
				if(null==paramMap.get("stockSumAdjustmentDir")||("").equals(paramMap.get("stockSumAdjustmentDir"))){
					
				}
				else{
					String dir = String.valueOf(paramMap.get("dir"));
					if(("A").equals(dir)){
						paramMap.put("stockSumAdjustmentDir", "DESC");
					}
					else if(("B").equals(dir)){
						paramMap.put("stockSumAdjustmentDir", "ASC");
					}
					else {
						paramMap.put("stockSumAdjustmentDir", "DESC");
					}
				}
				
				paramMap.put("useYn", "Y");
				
				List<Map<String, Object>> totalCountListMap = webStockSumAdjustmentSqlMapDAO.selectTotalStockSumAdjustmentCount(paramMap);
				int totalCount = Integer.parseInt(String.valueOf(totalCountListMap.get(0).get("totalCount")));
				
				if(0 < totalCount) {
					// 리스트 조회
					listMap = webStockSumAdjustmentSqlMapDAO.selectListStockSumAdjustment(paramMap);
				}
				
				map.put("msgCode", Constants.OK);
				map.put("success","true");
				map.put("totalCount", totalCount);
				map.put("rows",listMap);
			}

		}
		catch(Exception e){
			e.printStackTrace();
			throw e;
		}

		log.debug("WebStockSumAdjustmentServiceImpl selectListStockSumAdjustment END");
		return map;
	}
	
	/**
	 * 제품별 실시간 재고 현황 리스트 (재고조정 화면) 조회 (Excel)
	 *
	 *
	 * @param paramMap
	 * @return
	 * @throws Exception
	 */
	@Override
	public HashMap<String, Object> selectListStockSumAdjustmentExcel(
			HashMap<String, Object> paramMap) throws Exception {
		log.debug("WebStockSumAdjustmentServiceImpl selectListStockSumAdjustmentExcel START");

		HashMap<String, Object> map = new HashMap<String, Object>();

		log.debug("loginMemberId       :"+paramMap.get("loginMemberId"));
		
		log.debug("menuClass           :"+paramMap.get("menuClass"));
		
		log.debug("stockSumAdjustmentSearchKeywordParam  :"+paramMap.get("stockSumAdjustmentSearchKeywordParam"));
		log.debug("stockSumAdjustmentSort                :"+paramMap.get("stockSumAdjustmentSort"));
		log.debug("stockSumAdjustmentStart               :"+paramMap.get("stockSumAdjustmentStart"));
		log.debug("stockSumAdjustmentLimit               :"+paramMap.get("stockSumAdjustmentLimit"));
		log.debug("stockSumAdjustmentSort                :"+paramMap.get("stockSumAdjustmentSort"));
		log.debug("stockSumAdjustmentDir                 :"+paramMap.get("stockSumAdjustmentDir"));
		log.debug("stockSumAdjustmentCurrentPage         :"+paramMap.get("stockSumAdjustmentCurrentPage"));
		
		try{
			boolean check  = true;
			
			if(true == check){
				// 사용자 확인
				List<Map<String, Object>> userListMap = webMemberSqlMapDAO.checkMember(paramMap);
				int userListMapSize = userListMap.size();
				
				if(1==userListMapSize){
					paramMap.put("menuClassAuthId", userListMap.get(0).get("muAuthId"));
				}
				else {
					check = false;
					map.put("msgCode", Constants.FAIL);
					map.put("msgDesc", "사용자 정보가 올바르지 않습니다.");
				}
			}

			if(true == check){
				// 권한 조회
				HashMap<String, Object> authCheckParamMap = new HashMap<String, Object>();
				authCheckParamMap.put("menuClass",paramMap.get("menuClass"));
				authCheckParamMap.put("muAuthId",paramMap.get("menuClassAuthId"));
				List<Map<String, Object>> authMenuRelationlistMap = webAuthMenuRelationSqlMapDAO.selectAuthMenuRelation(authCheckParamMap);

				if(1==authMenuRelationlistMap.size()){

					if(("Y").equals(authMenuRelationlistMap.get(0).get("downloadUseYn"))) {

					}
					else {
						check = false;
						map.put("msgCode", Constants.FAIL);
						map.put("msgDesc", "내려받기 권한 정보가 없습니다.");
					}
				}
				else {
					check = false;
					map.put("msgCode", Constants.FAIL);
					map.put("msgDesc", "권한 정보가 없습니다.");
				}
			}

			if(true == check){
				// 정렬 
				if(null==paramMap.get("stockSumAdjustmentDir")||("").equals(paramMap.get("stockSumAdjustmentDir"))){
					
				}
				else{
					String dir = String.valueOf(paramMap.get("dir"));
					if(("A").equals(dir)){
						paramMap.put("stockSumAdjustmentDir", "DESC");
					}
					else if(("B").equals(dir)){
						paramMap.put("stockSumAdjustmentDir", "ASC");
					}
					else {
						paramMap.put("stockSumAdjustmentDir", "DESC");
					}
				}
				
				paramMap.put("useYn", "Y");
				
				List<Map<String, Object>> listMap = webStockSumAdjustmentSqlMapDAO.selectListStockSumAdjustmentExcel(paramMap);
				
				map.put("msgCode", Constants.OK);
				map.put("success","true");
				map.put("rows",listMap);
			}

		}
		catch(Exception e){
			e.printStackTrace();
			throw e;
		}

		log.debug("WebStockSumAdjustmentServiceImpl selectListStockSumAdjustmentExcel END");
		return map;
	}
}
